osgViewer::Keystone Class Reference

`#include <Keystone>`

Inheritance diagram for osgViewer::Keystone:

## Public Member Functions

| Keystone ()
| Keystone (const Keystone &rhs, const osg::CopyOp &copop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgViewer, Keystone) void reset()
Keystone & | operator= (const Keystone &rhs)
void | setKeystoneEditingEnabled (bool flag)
bool | getKeystoneEditingEnabled () const
void | setGridColor (const osg::Vec4 &color)
osg::Vec4 & | getGridColor ()
const osg::Vec4 & | getGridColor () const
void | setBottomLeft (const osg::Vec2d &v)
osg::Vec2d & | getBottomLeft ()
const osg::Vec2d & | getBottomLeft () const
void | setBottomRight (const osg::Vec2d &v)
osg::Vec2d & | getBottomRight ()
const osg::Vec2d & | getBottomRight () const
void | setTopLeft (const osg::Vec2d &v)
osg::Vec2d & | getTopLeft ()
const osg::Vec2d & | getTopLeft () const
void | setTopRight (const osg::Vec2d &v)
osg::Vec2d & | getTopRight ()
const osg::Vec2d & | getTopRight () const
void | compute3DPositions (osg::DisplaySettings *ds, osg::Vec3 &tl, osg::Vec3 &tr, osg::Vec3 &br, osg::Vec3 &bl) const
osg::Geode * | createKeystoneDistortionMesh ()
osg::Node * | createGrid ()
bool | writeToFile ()
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static bool | loadKeystoneFiles (osg::DisplaySettings *ds)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Member Functions

virtual | ~Keystone ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | keystoneEditingEnabled
osg::Vec4 | gridColour
osg::Vec2d | bottom_left
osg::Vec2d | bottom_right
osg::Vec2d | top_left
osg::Vec2d | top_right
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Constructor & Destructor Documentation

## Keystone() [1/2]

osgViewer::Keystone::Keystone | ( |  | ) |

Referenced by Keystone(), META_Object(), and operator=().

## Keystone() [2/2]

osgViewer::Keystone::Keystone | ( | const Keystone & | rhs,
|  | const osg::CopyOp & | copop = osg::CopyOp::SHALLOW_COPY )

References Keystone(), and osg::CopyOp::SHALLOW_COPY.

## ~Keystone()

virtual osgViewer::Keystone::~Keystone | ( |  | ) |

inline protected virtual

## Member Function Documentation

## compute3DPositions()

void osgViewer::Keystone::compute3DPositions | ( | osg::DisplaySettings * | ds,
|  | osg::Vec3 & | tl,
|  | osg::Vec3 & | tr,
|  | osg::Vec3 & | br,
|  | osg::Vec3 & | bl ) const

## createGrid()

osg::Node * osgViewer::Keystone::createGrid | ( |  | ) |

## createKeystoneDistortionMesh()

osg::Geode * osgViewer::Keystone::createKeystoneDistortionMesh | ( |  | ) |

## getBottomLeft() [1/2]

osg::Vec2d & osgViewer::Keystone::getBottomLeft | ( |  | ) |

inline

References bottom_left.

## getBottomLeft() [2/2]

const osg::Vec2d & osgViewer::Keystone::getBottomLeft | ( |  | ) | const

inline

References bottom_left.

## getBottomRight() [1/2]

osg::Vec2d & osgViewer::Keystone::getBottomRight | ( |  | ) |

inline

References bottom_right.

## getBottomRight() [2/2]

const osg::Vec2d & osgViewer::Keystone::getBottomRight | ( |  | ) | const

inline

References bottom_right.

## getGridColor() [1/2]

osg::Vec4 & osgViewer::Keystone::getGridColor | ( |  | ) |

inline

References gridColour.

## getGridColor() [2/2]

const osg::Vec4 & osgViewer::Keystone::getGridColor | ( |  | ) | const

inline

References gridColour.

## getKeystoneEditingEnabled()

bool osgViewer::Keystone::getKeystoneEditingEnabled | ( |  | ) | const

inline

References keystoneEditingEnabled.

## getTopLeft() [1/2]

osg::Vec2d & osgViewer::Keystone::getTopLeft | ( |  | ) |

inline

References top_left.

## getTopLeft() [2/2]

const osg::Vec2d & osgViewer::Keystone::getTopLeft | ( |  | ) | const

inline

References top_left.

## getTopRight() [1/2]

osg::Vec2d & osgViewer::Keystone::getTopRight | ( |  | ) |

inline

References top_right.

## getTopRight() [2/2]

const osg::Vec2d & osgViewer::Keystone::getTopRight | ( |  | ) | const

inline

References top_right.

## loadKeystoneFiles()

bool osgViewer::Keystone::loadKeystoneFiles | ( | osg::DisplaySettings * | ds | ) |

static

Convenience function that loads and assigns any keystone files specified in the DisplaySettings::KeystoneFileNames list, return true if Keystone's assigned to DisplaySettings.

## META_Object()

osgViewer::Keystone::META_Object | ( | osgViewer | ,
|  | Keystone | )

References Keystone().

## operator=()

Keystone & osgViewer::Keystone::operator= | ( | const Keystone & | rhs | ) |

References Keystone().

## setBottomLeft()

void osgViewer::Keystone::setBottomLeft | ( | const osg::Vec2d & | v | ) |

inline

References bottom_left.

## setBottomRight()

void osgViewer::Keystone::setBottomRight | ( | const osg::Vec2d & | v | ) |

inline

References bottom_right.

## setGridColor()

void osgViewer::Keystone::setGridColor | ( | const osg::Vec4 & | color | ) |

inline

References gridColour.

## setKeystoneEditingEnabled()

void osgViewer::Keystone::setKeystoneEditingEnabled | ( | bool | flag | ) |

inline

References keystoneEditingEnabled.

## setTopLeft()

void osgViewer::Keystone::setTopLeft | ( | const osg::Vec2d & | v | ) |

inline

References top_left.

## setTopRight()

void osgViewer::Keystone::setTopRight | ( | const osg::Vec2d & | v | ) |

inline

References top_right.

## writeToFile()

bool osgViewer::Keystone::writeToFile | ( |  | ) |

Write the file specified by the "filename" user value field. Return true if file successfully written.

## Member Data Documentation

## bottom_left

osg::Vec2d osgViewer::Keystone::bottom_left

protected

Referenced by getBottomLeft(), getBottomLeft(), and setBottomLeft().

## bottom_right

osg::Vec2d osgViewer::Keystone::bottom_right

protected

Referenced by getBottomRight(), getBottomRight(), and setBottomRight().

## gridColour

osg::Vec4 osgViewer::Keystone::gridColour

protected

Referenced by getGridColor(), getGridColor(), and setGridColor().

## keystoneEditingEnabled

bool osgViewer::Keystone::keystoneEditingEnabled

protected

Referenced by getKeystoneEditingEnabled(), and setKeystoneEditingEnabled().

## top_left

osg::Vec2d osgViewer::Keystone::top_left

protected

Referenced by getTopLeft(), getTopLeft(), and setTopLeft().

## top_right

osg::Vec2d osgViewer::Keystone::top_right

protected

Referenced by getTopRight(), getTopRight(), and setTopRight().

The documentation for this class was generated from the following file:

- Keystone